package io.xjar.filter;

import io.xjar.XEntryFilter;

public abstract class XAntEntryFilter<E> extends XRegexEntryFilter<E> implements XEntryFilter<E>
{
    private static final String[] SYMBOLS;
    
    protected XAntEntryFilter(final String ant) {
        super(convert(ant));
    }
    
    private static String convert(final String ant) {
        String regex = ant;
        for (final String symbol : XAntEntryFilter.SYMBOLS) {
            regex = regex.replace(symbol, '\\' + symbol);
        }
        for (regex = regex.replace("?", ".{1}"), regex = regex.replace("**/", "(.{0,}?/){0,}?"), regex = regex.replace("**", ".{0,}?"), regex = regex.replace("*", "[^/]{0,}?"); regex.startsWith("/"); regex = regex.substring(1)) {}
        while (regex.endsWith("/")) {
            regex = regex.substring(0, regex.length() - 1);
        }
        return regex;
    }
    
    static {
        SYMBOLS = new String[] { "\\", "$", "(", ")", "+", ".", "[", "]", "^", "{", "}", "|" };
    }
}
